﻿using System;
using System.Collections.Generic;
using System.Linq;
using Luticate2.Auth.Auth.DataAccess;
using Luticate2.Auth.Auth.DataAccess.Models;
using Luticate2.Auth.Auth.Dbo;
using Luticate2.Auth.Utils.Business.Fields;
using Luticate2.Auth.Utils.DataAccess.Crud;
using Luticate2.Auth.Utils.Dbo.Fields;
using Luticate2.Auth.Utils.Dbo.Result;
using Microsoft.EntityFrameworkCore;

namespace Luticate2.Auth.Auth.Business
{
    public class LuGroupsBusiness : LuEfCrudDataAccess<LuGroupDbo, LuGroups, Luticate2DbContext>
    {
        public LuGroupsBusiness(IServiceProvider serviceProvider) : base(serviceProvider)
        {
        }

        protected override LuResult<IQueryable<LuGroups>> Include(LuPartialFieldsDbo partialResponse, IQueryable<LuGroups> queryable)
        {
            var included = queryable;
            if (partialResponse.Fields.IsIncluded<LuGroupDbo>(x => x.Metadata))
            {
                included = included.Include(x => x.IdNavigation);
            }

            return LuResult<IQueryable<LuGroups>>.Ok(included);
        }
    }
}